
package de.ivu.elect.was.exchange.ergebnis.eml;

import java.util.List;

import javax.annotation.Nullable;

import org.apache.commons.lang3.StringUtils;

import de.ivu.elect.business.datei.entity.FileType;
import de.ivu.elect.business.ergebnis.control.ErgebnisExportContext;
import de.ivu.elect.business.ergebnis.control.ErgebnisExportObject;
import de.ivu.elect.business.exchange.control.FileFormat;
import de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet;
import de.ivu.elect.business.wahl.entity.NlWahlart;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.nl.eml.readable.ReportingUnitVotesWrapper;
import de.ivu.elect.was.exchange.stimmeingabe.Eml510;

public class Eml510bGSBErgebnisExportMapper extends Abstract510ErgebnisExportMapper {

  private static final long serialVersionUID = 1L;

  public static final FileFormat FILE_FORMAT = new FileFormat("eml.510b.file.format", FileType.ZIP);

  public Eml510bGSBErgebnisExportMapper() {
    super();
  }

  @Override
  protected String getEmlId() {
    return Eml510.EML510b.getId();
  }

  @Override
  public FileFormat getFileFormat() {
    return FILE_FORMAT;
  }

  @Override
  public boolean isSignEml(Wahl wahl) {
    return !(isHSB(wahl) && isCSB(wahl)); // ELECTVAPP-718, siehe auch https://support.elect-it.com/wiki/display/VAPP/EML-Import+validation...
  }

  @Override
  protected boolean isGsbNotwendig() {
    return true;
  }

  @Override
  protected boolean isHsbNotwendig() {
    return false;
  }

  @Override
  protected boolean isCsbNotwendig() {
    return false;
  }

  @Override
  protected boolean isGebietAuswahlNotwendig() {
    return false;
  }

  @Override
  protected boolean isErfassungsgebietAuswahlNotwendig() {
    return false;
  }

  @Override
  protected boolean isErgebnisNotwendig() {
    return true;
  }

  @Override
  protected List<Wahldurchfuehrungsgebiet> bestimmeReportingUnitGebiete(ErgebnisExportObject ergebnisExportObject, ErgebnisExportContext context) {
    return ergebnisExportObject.getErgebnisDaten().getErfassungsgebiete();
  }

  @Nullable
  @Override
  protected Wahldurchfuehrungsgebiet bestimmeTotalVotesGebiet(ErgebnisExportObject ergebnisExportObject, ErgebnisExportContext context) {
    return ergebnisExportObject.getErgebnisDaten().getWurzelgebiet();
  }

  @Nullable
  @Override
  protected Wahldurchfuehrungsgebiet bestimmeGebietFuerDaten(ErgebnisExportObject ergebnisExportObject, ErgebnisExportContext context) {
    return ergebnisExportObject.getErgebnisDaten().getWurzelgebiet();
  }

  @Override
  protected String getAuthorityIdPrefix(ErgebnisExportObject ergebnisExportObject) {
    return "";
  }

  @Override
  protected String createdByAuthorityIdPrefix(ErgebnisExportObject ergebnisExportObject) {
    return "";
  }

  @Override
  protected boolean is510a() {
    return false;
  }

  @Override
  protected boolean is510b() {
    return true;
  }

  @Override
  protected boolean is510c() {
    return false;
  }

  @Override
  protected boolean is510d() {
    return false;
  }

  @Override
  protected boolean is520() {
    return false;
  }

  @Override
  protected void fillReportingUnit(Wahldurchfuehrungsgebiet reportingUnitGebiet, ReportingUnitVotesWrapper reportingUnitVotesWrapper) {
    // ELECTVAPP-491 und ELECT-13760 und ELECT-13807
    NlWahlart nlWahlart = NlWahlart.valueOf(reportingUnitGebiet.getWahl());
    reportingUnitVotesWrapper
        .setId(getMessage(nlWahlart.getEml510bIdMessageKey(), reportingUnitGebiet.getNummer(), nlGebietDarstellungNummerFormatter.formatiereNummer(reportingUnitGebiet.getUebergeordnetesGebiet())));

    if (nlWahlart.isEml510bNameAusgaben()) {
      if (StringUtils.isBlank(reportingUnitGebiet.getAnschrift().getPlz())) {
        reportingUnitVotesWrapper.setName(getMessage("eml510b.reporting.unit.name.stimmbuero.ohne.plz", reportingUnitGebiet.getName()));
      } else {
        reportingUnitVotesWrapper.setName(getMessage("eml510b.reporting.unit.name.stimmbuero", reportingUnitGebiet.getName(), reportingUnitGebiet.getAnschrift().getPlz()));
      }
    }
  }
}
